import {
  world,
  system
} from "@minecraft/server";


import { getColor, getConfig } from "./Chat/NameMessageColor/NameMessageColor.js";

import { getRank } from "./Chat/getRank/getRank.js";

import {
  NAMETAG_COLOR_PREFIX
} from "./Chat/NameMessageColor/Config/NameColorConfig.js";

import {
  CHAT_COLOR_PREFIX
} from "./Chat/NameMessageColor/Config/MessageColorConfig.js";

import Cooldown, { COOLDOWNS } from "./Chat/SmellyCoolDown/cooldown.js"


// Disable Script Watch Dog Terminate
system.events.beforeWatchdogTerminate.subscribe(({ cancel }) => {
  cancel = true
})

/**
 * Await till world loaded to call a functiom
 * @param {(data: BeforeChatEvent, args: Array<string>) => void} callback Code you want to execute when the command is executed
 * @example
 *  onWorldLoad(function () {
 *    console.log(`world loaded`)
 * });
 */

world.events.beforeChat.subscribe((data) => {

  data.cancel = true
  let player = data.sender

  // Test if player is muted 
  if (player.hasTag('mute')) {

    // Send mute chat message
    player.tell(`§7[§r§3Chat§bColors§7]§r §3You are muted!`)

  } else {

    // Smelly CoolDown
    const cooldown = COOLDOWNS[player.name];

    if (cooldown) return cooldown.reply(player);
    new Cooldown(player.name);

    // send chat message 
    world.say("§r" + getConfig(player, 'dimension') + "§7[§f" + getRank(player) + "§7] " + getColor(player, NAMETAG_COLOR_PREFIX, player.name) + "§7§l > §r" + getColor(player, CHAT_COLOR_PREFIX, data.message.replace('§', '')))


  }

});


// Apply ranks and colors in Player NameTag 


system.runSchedule(function tick(data) {
  for (const player of world.getPlayers()) {

    // Set Player NameTag
    player.nameTag = "§r" + getConfig(player, 'dimension') + "§7[§f" + getRank(player) + "§7]§r " + getColor(player, NAMETAG_COLOR_PREFIX, player.name) + "§r" + getConfig(player, 'health')

  }
}, 1)